<!DOCTYPE html>
<html>

<head>
    <title>Php Crop Image Before Upload Example - abdultechhub.com</title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap/5.2.3/css/bootstrap.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/cropperjs/1.5.6/cropper.css" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap/5.2.3/js/bootstrap.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/cropperjs/1.5.6/cropper.js"></script>
</head>
<style type="text/css">
    body {
        background: #f7fbf8;
    }

    h1 {
        font-weight: bold;
        font-size: 23px;
    }

    img {
        display: block;
        max-width: 100%;
    }

    .preview {
        text-align: center;
        overflow: hidden;
        width: 160px;
        height: 160px;
        margin: 10px;
        border: 1px solid red;
    }

    input {
        margin-top: 40px;
    }

    .section {
        margin-top: 150px;
        background: #fff;
        padding: 50px 30px;
    }

    .modal-lg {
        max-width: 1000px !important;
    }

    .error {
        color: red;
    }
</style>

<body>

    <div class="container">
        <div class="row">

            <div class="col-md-8 offset-md-2 section text-center">
                <?php
                if (isset($_GET['success']) && $_GET['success'] == 1) {
                ?>
                    <div class="alert alert-success alert-dismissible fade show text-left" role="alert">
                        <strong>Success!</strong> File Uploaded successfully
                        <a href="index.php" class="btn-close"></a>
                    </div>
                <?php

                }
                ?>
                <h1>PHP Crop Image Before Upload Example - abdultechhub.com</h1>
                <form action="upload_image.php" method="POST">
                    <input type="file" name="image" class="image form-control" accept=".jpg, .jpeg, .png, .webp">
                    <span class="error" id="fileError"></span>
                    <input type="hidden" name="image_base64" id="imageBase64">
                    <span class="error" id="base64Error"></span>
                    <img src="" style="width: 200px;display: none;" class="show-image">

                    <br />
                    <button class="btn btn-success">Submit</button>
                </form>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">

                <div class="modal-header">
                    <h1 class="modal-title fs-5" id="exampleModalLabel">Crop Image:</h1>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>


                <div class="modal-body">
                    <div class="img-container">
                        <div class="row">
                            <div class="col-md-8">
                                <img id="image" src="https://avatars0.githubusercontent.com/u/3456749">
                            </div>
                            <div class="col-md-4">
                                <div class="preview"></div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" id="doNotCrop">Do not crop</button>
                    <button type="button" class="btn btn-primary" id="crop">Crop</button>
                </div>
            </div>
        </div>
    </div>

    <script>
        var $modal = $('#modal');
        var image = document.getElementById('image');
        var cropper;

        $("body").on("change", ".image", function(e) {
            var files = e.target.files;
            var done = function(url) {
                image.src = url;
                $modal.modal('show');
            };

            var reader;
            var file;
            var url;

            if (files && files.length > 0) {
                file = files[0];

                // Check if the file extension is allowed
                var allowedExtensions = /(\.jpg|\.jpeg|\.png|\.webp)$/i;
                if (!allowedExtensions.exec(file.name)) {
                    $('#fileError').text('Only JPG, JPEG, PNG, and WebP files are allowed.');
                    return;
                } else {
                    $('#fileError').text('');
                }

                if (URL) {
                    done(URL.createObjectURL(file));
                } else if (FileReader) {
                    reader = new FileReader();
                    reader.onload = function(e) {
                        done(reader.result);
                    };
                    reader.readAsDataURL(file);
                }
            }
        });

        $modal.on('shown.bs.modal', function() {
            cropper = new Cropper(image, {
                aspectRatio: 0,
                viewMode: 3,
                preview: '.preview'
            });
        }).on('hidden.bs.modal', function() {
            cropper.destroy();
            cropper = null;
        });

        $("#crop").click(function() {
            canvas = cropper.getCroppedCanvas({
                width: 160,
                height: 160,
            });

            canvas.toBlob(function(blob) {
                url = URL.createObjectURL(blob);
                var reader = new FileReader();
                reader.readAsDataURL(blob);
                reader.onloadend = function() {
                    var base64data = reader.result;
                    $("#imageBase64").val(base64data);
                    $(".show-image").show();
                    $(".show-image").attr("src", base64data);
                    $("#modal").modal('toggle');
                }
            });
        });

        // Do Not Crop button click event
        $("#doNotCrop").click(function() {
            var input = $(".image")[0];
            var file = input.files[0];
            var reader = new FileReader();

            reader.onloadend = function() {
                var base64data = reader.result;
                $("#imageBase64").val(base64data);
                $(".show-image").show();
                $(".show-image").attr("src", base64data);
                $("#modal").modal('toggle');
            };

            reader.readAsDataURL(file);
        });

        // Validate base64 input on form submit
        $("form").submit(function() {
            if ($("#imageBase64").val() === "") {
                $('#base64Error').text('Base64 input is required.');
                return false;
            } else {
                $('#base64Error').text('');
            }
        });
    </script>
</body>

</html>